<?php

/*
Plugin Name: Custom Profile Filters for BuddyPress
Plugin URI: http://dev.commons.gc.cuny.edu/
Description: Allows BP users to determine manually which words and phrases in their profile fields turn into links
Version: 0.1
Author: Boone Gorges
Author URI: http://teleogistic.net

** Created as part of the CUNY Academic Commons project: http://commons.gc.cuny.edu **
*/


function xprofile_filter_link_profile_data_cac( $field_value, $field_type = 'textbox' ) {
	if ( 'datebox' == $field_type )
		return $field_value;
	
if ( strpos( $field_value, '[' ) | strpos( $field_value, ']' ) ) { // If there is a bracket in a field, this block overrides the auto-linking

	while ( strpos( $field_value, ']') ) {
		$open_delin_pos = strpos( $field_value, '[' );
		$close_delin_pos = strpos( $field_value, ']' );
		$field_value =  substr($field_value, 0, $open_delin_pos) . '<a href="' . site_url( BP_MEMBERS_SLUG ) . '/?s=' . substr($field_value, $open_delin_pos+1, $close_delin_pos - $open_delin_pos - 1) . '">' . substr($field_value, $open_delin_pos+1, $close_delin_pos - $open_delin_pos - 1) . '</a>' . substr($field_value, $close_delin_pos+1);
	}
	
	return $field_value ;
	


} else {
	
	
	if ( !strpos( $field_value, ',' ) && ( count( explode( ' ', $field_value ) ) > 5 ) )
		return $field_value;
	
	
	$values = explode( ',', $field_value );

	if ( $values ) {
		foreach ( $values as $value ) {
			$value = trim( $value );
			
			/* If the value is a URL, skip it and just make it clickable. */
			if ( preg_match( '@(https?://([-\w\.]+)+(:\d+)?(/([\w/_\.]*(\?\S+)?)?)?)@', $value ) ) {
				$new_values[] = make_clickable( $value );
			} else {
				if ( count( explode( ' ', $value ) ) > 5 )
					$new_values[] = $value;
				else
					$new_values[] = '<a href="' . site_url( BP_MEMBERS_SLUG ) . '/?s=' . $value . '">' . $value . '</a>';
			}
		}
		
		$values = implode( ', ', $new_values );
	}
	
	return $values;
}
}



function stuff_i_want_triggered_after_bp_loads(){

remove_filter( 'bp_get_the_profile_field_value', 'xprofile_filter_link_profile_data', 2, 2);
add_filter( 'bp_get_the_profile_field_value', 'xprofile_filter_link_profile_data_cac', 3, 2);
}
add_action('wp', 'stuff_i_want_triggered_after_bp_loads'); 

/*add_action('admin_menu', 'bp_profile_custom_filters_plugin_menu');*/


?>

<?php
/*  Copyright 2009  Boone Gorges  (email : boonebgorges@gmail.com )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
?>
